package top.daxian1218.dust.service.common;

import com.alibaba.fastjson.serializer.ValueFilter;
import top.daxian1218.dust.commons.data.HDataRow;
import top.daxian1218.dust.commons.data.HDataRowCollection;
import top.daxian1218.dust.commons.data.HDataTable;
import top.daxian1218.dust.commons.util.TimestampUtil;
import top.daxian1218.dust.db.dict.DictObj;
import top.daxian1218.dust.db.dict.DictObjRow;

import java.math.BigDecimal;
import java.util.Date;

import static top.daxian1218.dust.commons.data.HDataRow.JS_NUMBER_MAX;

/**
 * @author daxian
 */
public class DustJsonValueFilter implements ValueFilter {

    @Override
    public Object process(Object object, String name, Object source) {
        if (source == null) {
            return null;
        }

        if (source instanceof DictObj) {
            DictObj obj = (DictObj) source;
            if (obj.getPageInfo().getPageSize() > 0) {
                return obj.toPageDataJSON();
            }
            return ((DictObj) source).toDataJSON();
        }

        if (source instanceof Long) {
            long l = (long) source;
            return l > JS_NUMBER_MAX ? source.toString() : source;
        }

        if (source instanceof BigDecimal) {
            BigDecimal d = (BigDecimal) source;
            return d.longValue() > JS_NUMBER_MAX ? source.toString() : source;
        }

        return source;
    }
}
