package top.daxian1218.dust.service.config;

import org.slf4j.LoggerFactory;
import top.daxian1218.dust.commons.log.LoggerHelper;
import top.daxian1218.dust.commons.reflection.IBeanFactory;
import top.daxian1218.dust.commons.util.BeanUtil;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Configuration;

/**
 * 通用工具AutoConfig, 关联Spring AppicalitionContext和BeanUtil
 * @author hst
 */
@Configuration
public class CommonsAutoConfiguration {
    public CommonsAutoConfiguration(ApplicationContext context) {
        BeanUtil.FACTORY = new IBeanFactory() {
            @Override
            public <T> T getBean(Class<T> cls) {
                return context.getBean(cls);
            }

            @Override
            public <T> Iterable<T> getBeans(Class<T> cls) {
                return null;
            }

            @Override
            public Object getBean(String name) {
                if (context.containsBean(name)) {
                    return context.getBean(name);
                }
                return null;
            }
        };

    }
}
