package top.daxian1218.dust.service.config;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mongodb.core.MongoTemplate;
import top.daxian1218.dust.service.repository.MongoRepository;
import top.daxian1218.dust.service.security.jwt.EncodeProvider;
import top.daxian1218.dust.service.util.EnProperty;

/**
 * 用于自定义的Component目录
 * @author hst
 */
@Configuration
public class ComponentConfiguration {
    @Bean
    public EncodeProvider encodeProvider() {
        return new EncodeProvider();
    }

    @Bean
    public EnProperty enProperty() {
        return new EnProperty();
    }

    @SuppressWarnings("SpringJavaAutowiringInspection")
    @Bean
    @ConditionalOnProperty("spring.data.mongodb.uri")
    public MongoRepository mongoRepository(MongoTemplate mongoTemplate) {
        return new MongoRepository(mongoTemplate);
    }
}
