package top.daxian1218.dust.service.config;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import top.daxian1218.dust.db.DbAdapterManager;
import top.daxian1218.dust.db.DbManager;
import top.daxian1218.dust.db.DustDbProperties;
import top.daxian1218.dust.db.tenant.AppManager;
import top.daxian1218.dust.db.tenant.SeparatedCache;
import top.daxian1218.dust.db.tenant.TenantManager;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.event.EventListener;

/**
 * @author hst
 */
@Configuration
public class TenantAutoConfiguration {
    @Bean
    public SeparatedCache separatedCache() {
        return new SeparatedCache();
    }


    @Bean
    public TenantManager tenantAdapterManager(DbAdapterManager dbAdapterManager, @Autowired(required = false) AppManager appManager) {
        return new TenantManager(dbAdapterManager, appManager);
    }

    @Bean(initMethod = "init")
    @ConditionalOnProperty("dust.db.tenant.enable")
    public AppManager appManager(DustDbProperties dustDbProperties, DbAdapterManager dbAdapterManager) {
        return new AppManager(dustDbProperties.getTenant().getDbName(), dbAdapterManager);
    }
}
